unit fMain;

interface

uses
  Classes, Controls, Forms, ExtCtrls, Grids, StdCtrls;

const
  COLUMN_NAMES: array[0..12] of string = (
    'OPDCASNO', 'OPDORSQN', 'ORSTATUS', 'ORTYPE'  , 'ORPROCED', 'ORFREQN',
    'ORPRICE' , 'ORQNTY'  , 'ORDOCNO' , 'ORDOCNM' , 'ORDATE'  , 'ORTIME' ,
    'ENDSYMBOL');
    
type
  TRec = packed record
    case Integer of
      0:(Data: array[0..94] of Char;);
      1:(
          OPDCASNO  : array[0..7] of Char;//CHAR(08)  01~08 E
          OPDORSQN  : array[0..3] of Char;//CHAR(04)  09~13 Ǹ
          ORSTATUS  : array[0..1] of Char;//CHAR(02)  13~14 AX
          ORTYPE    : array[0..2] of Char;//CHAR(03)  15~17 }߳
          ORPROCED  : array[0..31]of Char;//CHAR(32)  18~49 W
          ORFREQN   : array[0..7] of Char;//CHAR(08)  50~57 Wv
          ORPRICE   : array[0..7] of Char;//CHAR(08)  58~65 
          ORQNTY    : array[0..3] of Char;//CHAR(04)  66~69 ƶq
          ORDOCNO   : array[0..4] of Char;//CHAR(05)  70~74 v
          ORDOCNM   : array[0..9] of Char;//CHAR(10)  75~84 vmW
          ORDATE    : array[0..5] of Char;//CHAR(06)  85~90 }ߤ
          ORTIME    : array[0..3] of Char;//CHAR(04)  91~94 }߮ɶ
          ENDSYMBOL : Char;               //CHAR(01)  95~95 Ÿ(#)
        );
  end;

  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    grid: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    Loaded: Boolean;
  end;

var
  Form1: TForm1;

implementation

uses SysUtils, Math;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  I: Integer;
  S: string;
begin
  grid.ColCount := Length(COLUMN_NAMES);
  for I := 0 to grid.ColCount-1 do
  begin
    S := COLUMN_NAMES[I];
    grid.Cells[I, 0] := S;
    case I of
      4: grid.ColWidths[I] := grid.Canvas.TextWidth(S) + 50;
      else grid.ColWidths[I] := grid.Canvas.TextWidth(S) + 10;
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  I, J: Integer;
  R: TRec;
  L: TStringList;
  FileName: string;
begin
  Loaded := True;
  FileName := 'FILE1.TXT';
  if FileExists(FileName) then
  begin
    L := TStringList.Create;
    try
      L.LoadFromFile(FileName);
      grid.RowCount := L.Count+1;
      for I := 0 to L.Count-1 do
      begin
        Move(PChar(L[I])^, R, SizeOf(R));
        for J := 0 to grid.ColCount-1 do
          case J of
            0: grid.Cells[J, I+1] := Trim(R.OPDCASNO );
            1: grid.Cells[J, I+1] := Trim(R.OPDORSQN );
            2: grid.Cells[J, I+1] := Trim(R.ORSTATUS );
            3: grid.Cells[J, I+1] := Trim(R.ORTYPE   );
            4: grid.Cells[J, I+1] := Trim(R.ORPROCED );
            5: grid.Cells[J, I+1] := Trim(R.ORFREQN  );
            6: grid.Cells[J, I+1] := Trim(R.ORPRICE  );
            7: grid.Cells[J, I+1] := Trim(R.ORQNTY   );
            8: grid.Cells[J, I+1] := Trim(R.ORDOCNO  );
            9: grid.Cells[J, I+1] := Trim(R.ORDOCNM  );
            10:grid.Cells[J, I+1] := Trim(R.ORDATE   );
            11:grid.Cells[J, I+1] := Trim(R.ORTIME   );
            12:grid.Cells[J, I+1] := Trim(R.ENDSYMBOL);
          end;
      end;
    finally
      FreeAndNil(L);
    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I, J, K: Integer;
  R: TRec;
  L: TStringList;
  S, FileName: string;
begin
  if not Loaded then Exit;
  FileName := 'FILE2.TXT';
  L := TStringList.Create;
  try
    for I := 1 to grid.RowCount-1 do
    begin
      FillChar(R, SizeOf(R), #$20);
      for J := 0 to grid.ColCount-1 do
      begin
        S := Trim(grid.Cells[J, I]);
        K := Length(S);
        case J of
          0: Move(PChar(S)^, R.OPDCASNO  , Min(K,SizeOf(R.OPDCASNO )));
          1: Move(PChar(S)^, R.OPDORSQN  , Min(K,SizeOf(R.OPDORSQN )));
          2: Move(PChar(S)^, R.ORSTATUS  , Min(K,SizeOf(R.ORSTATUS )));
          3: Move(PChar(S)^, R.ORTYPE    , Min(K,SizeOf(R.ORTYPE   )));
          4: Move(PChar(S)^, R.ORPROCED  , Min(K,SizeOf(R.ORPROCED )));
          5: Move(PChar(S)^, R.ORFREQN   , Min(K,SizeOf(R.ORFREQN  )));
          6: Move(PChar(S)^, R.ORPRICE   , Min(K,SizeOf(R.ORPRICE  )));
          7: Move(PChar(S)^, R.ORQNTY    , Min(K,SizeOf(R.ORQNTY   )));
          8: Move(PChar(S)^, R.ORDOCNO   , Min(K,SizeOf(R.ORDOCNO  )));
          9: Move(PChar(S)^, R.ORDOCNM   , Min(K,SizeOf(R.ORDOCNM  )));
          10:Move(PChar(S)^, R.ORDATE    , Min(K,SizeOf(R.ORDATE   )));
          11:Move(PChar(S)^, R.ORTIME    , Min(K,SizeOf(R.ORTIME   )));
          12:Move(PChar(S)^, R.ENDSYMBOL , Min(K,SizeOf(R.ENDSYMBOL)));
        end;
      end;
      L.Add(R.Data);
    end;
    L.SaveToFile(FileName);
  finally
    FreeAndNil(L);
  end;
end;

end.
